
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.agent.core.groups &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../../" src="../../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" />
   
  <link rel="stylesheet" href="../../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.agent.core.groups</h1><div class="highlight"><pre>
<span></span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="sd">.. module:: emulsion.agent.core.groups</span>

<span class="sd">.. moduleauthor:: Sébastien Picault &lt;sebastien.picault@inra.fr&gt;</span>

<span class="sd">Part of this code was adapted from the PADAWAN framework (S. Picault,</span>
<span class="sd">Univ. Lille).</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>

<span class="kn">import</span> <span class="nn">abc</span>

<span class="kn">from</span>   <span class="nn">emulsion.agent.core.emulsion_agent</span>  <span class="k">import</span> <span class="n">EmulsionAgent</span>

<span class="c1">#   _____                                               _</span>
<span class="c1">#  / ____|                        /\                   | |</span>
<span class="c1"># | |  __ _ __ ___  _   _ _ __   /  \   __ _  ___ _ __ | |_</span>
<span class="c1"># | | |_ | &#39;__/ _ \| | | | &#39;_ \ / /\ \ / _` |/ _ \ &#39;_ \| __|</span>
<span class="c1"># | |__| | | | (_) | |_| | |_) / ____ \ (_| |  __/ | | | |_</span>
<span class="c1">#  \_____|_|  \___/ \__,_| .__/_/    \_\__, |\___|_| |_|\__|</span>
<span class="c1">#                        | |            __/ |</span>
<span class="c1">#                        |_|           |___/</span>

<div class="viewcode-block" id="GroupAgent"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.GroupAgent">[docs]</a><span class="k">class</span> <span class="nc">GroupAgent</span><span class="p">(</span><span class="n">EmulsionAgent</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;A GroupAgent is aimed at representing a group of agents. The</span>
<span class="sd">    underlying level may be either explicitly represented (using a</span>
<span class="sd">    ViewCompartment) or aggregated (using an Compartment). Each</span>
<span class="sd">    compartment is associated with keys, i.e. a tuple of state</span>
<span class="sd">    variables (possibly empty) which play a crucial role in this</span>
<span class="sd">    compartment.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="GroupAgent.__init__"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.GroupAgent.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="p">(),</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">keys</span> <span class="o">=</span> <span class="n">keys</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">autoremove</span> <span class="o">=</span> <span class="kc">False</span></div>


<div class="viewcode-block" id="GroupAgent.add"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.GroupAgent.add">[docs]</a>    <span class="nd">@abc</span><span class="o">.</span><span class="n">abstractmethod</span>
    <span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified population to the current compartment.&quot;&quot;&quot;</span>
        <span class="k">pass</span></div>

<div class="viewcode-block" id="GroupAgent.remove"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.GroupAgent.remove">[docs]</a>    <span class="nd">@abc</span><span class="o">.</span><span class="n">abstractmethod</span>
    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the specified population from the current</span>
<span class="sd">        compartment.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">pass</span></div>

    <span class="nd">@abc</span><span class="o">.</span><span class="n">abstractmethod</span>
    <span class="k">def</span> <span class="nf">_base_move</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other_unit</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="k">pass</span>

    <span class="k">def</span> <span class="nf">_before_move</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">,</span> <span class="n">old_state</span><span class="p">,</span> <span class="n">new_state</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="c1"># execute actions when exiting current state (if any)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_exit&#39;</span><span class="p">,</span>
                              <span class="n">state_machine</span><span class="p">,</span>
                              <span class="n">old_state</span><span class="p">,</span>
                              <span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="c1"># execute actions when crossing edge (if any)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">do_edge_actions</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="c1"># update states of atom units</span>
        <span class="k">if</span> <span class="s1">&#39;agents&#39;</span> <span class="ow">in</span> <span class="n">others</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="n">others</span><span class="p">[</span><span class="s1">&#39;agents&#39;</span><span class="p">]:</span>
                <span class="n">unit</span><span class="o">.</span><span class="n">change_state</span><span class="p">(</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span><span class="p">,</span>
                                  <span class="n">state_machine</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">new_state</span><span class="p">])</span>
                <span class="c1"># unit.statevars[state_machine.machine_name] =\</span>
                <span class="c1">#   state_machine.states[new_state]</span>

    <span class="k">def</span> <span class="nf">_after_move</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">,</span> <span class="n">new_state</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="c1"># execute actions when entering new state (if any)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_enter&#39;</span><span class="p">,</span>
                              <span class="n">state_machine</span><span class="p">,</span>
                              <span class="n">new_state</span><span class="p">,</span>
                              <span class="o">**</span><span class="n">others</span><span class="p">)</span>



<div class="viewcode-block" id="GroupAgent.move_to"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.GroupAgent.move_to">[docs]</a>    <span class="k">def</span> <span class="nf">move_to</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other_unit</span><span class="p">,</span> <span class="n">state_machine</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Move the specified population from the current population</span>
<span class="sd">        of the compartment to the other unit. If a state machine is</span>
<span class="sd">        provided, executes the corresponding actions when</span>
<span class="sd">        entering/exiting nodes and crossing edges if needed.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">state_machine</span><span class="p">:</span>
            <span class="c1">#old_state = self.get_information(state_machine.machine_name).name</span>
            <span class="n">old_state</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span><span class="p">]</span>
            <span class="n">new_state</span> <span class="o">=</span> <span class="n">other_unit</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span><span class="p">]</span><span class="o">.</span><span class="n">name</span>
            <span class="k">if</span> <span class="n">old_state</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">_before_move</span><span class="p">(</span><span class="n">state_machine</span><span class="p">,</span> <span class="n">old_state</span><span class="o">.</span><span class="n">name</span><span class="p">,</span>
                                  <span class="n">new_state</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="c1"># move population from current compartment to other unit</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_base_move</span><span class="p">(</span><span class="n">other_unit</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">state_machine</span><span class="p">:</span>
            <span class="n">other_unit</span><span class="o">.</span><span class="n">_after_move</span><span class="p">(</span><span class="n">state_machine</span><span class="p">,</span> <span class="n">new_state</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">)</span></div></div>



<span class="c1">#                                           _   _</span>
<span class="c1">#     /\                                   | | (_)</span>
<span class="c1">#    /  \   __ _  __ _ _ __ ___  __ _  __ _| |_ _  ___  _ __</span>
<span class="c1">#   / /\ \ / _` |/ _` | &#39;__/ _ \/ _` |/ _` | __| |/ _ \| &#39;_ \</span>
<span class="c1">#  / ____ \ (_| | (_| | | |  __/ (_| | (_| | |_| | (_) | | | |</span>
<span class="c1"># /_/    \_\__, |\__, |_|  \___|\__, |\__,_|\__|_|\___/|_| |_|</span>
<span class="c1">#           __/ | __/ |          __/ |</span>
<span class="c1">#          |___/ |___/          |___/</span>


<div class="viewcode-block" id="Aggregation"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.Aggregation">[docs]</a><span class="k">class</span> <span class="nc">Aggregation</span><span class="p">(</span><span class="n">GroupAgent</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;An Aggregation is aimed at grouping agents from the underlying</span>
<span class="sd">    level. Thus, aggregate information such as the total number of</span>
<span class="sd">    agents in the compartment (population) is calculated from the</span>
<span class="sd">    actual content of the compartment. The evolution of a</span>
<span class="sd">    ViewCompartment, by default, consists in making the units</span>
<span class="sd">    contained in the compartment evolve themselves, unless</span>
<span class="sd">    `recursive=False` is specified during instantiation.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="Aggregation.__init__"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.Aggregation.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">recursive</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="o">**</span><span class="n">others</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_content</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">recursive</span> <span class="o">=</span> <span class="n">recursive</span></div>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">population</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Return the total population of the compartment. It is</span>
<span class="sd">        calculated either using a true &#39;population&#39; statevar if any,</span>
<span class="sd">        or as the sum of the population of each unit contained in the</span>
<span class="sd">        compartment.</span>

<span class="sd">        TAG: USER</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1">## DEBUG</span>
        <span class="c1"># print(&#39;\t\tstatevars.population:&#39;, self.statevars.population if &#39;population&#39; in self.statevars else &#39;None&#39;, [f&#39;{unit.agid}-&gt;{unit._host}&#39; for unit in self])</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">population</span> <span class="k">if</span> <span class="s1">&#39;population&#39;</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span>\
            <span class="k">else</span> <span class="nb">sum</span><span class="p">([</span><span class="n">unit</span><span class="o">.</span><span class="n">get_information</span><span class="p">(</span><span class="s1">&#39;population&#39;</span><span class="p">)</span>
                      <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">])</span>

<div class="viewcode-block" id="Aggregation.add"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.Aggregation.add">[docs]</a>    <span class="k">def</span> <span class="nf">add</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add the specified population to the current compartment.&quot;&quot;&quot;</span>
        <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="n">population</span><span class="p">:</span>
            <span class="n">unit</span><span class="o">.</span><span class="n">add_host</span><span class="p">(</span><span class="bp">self</span><span class="p">)</span></div>

<div class="viewcode-block" id="Aggregation.remove"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.Aggregation.remove">[docs]</a>    <span class="k">def</span> <span class="nf">remove</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">population</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Remove the specified population from the current</span>
<span class="sd">        compartment.</span>

<span class="sd">        &quot;&quot;&quot;</span>
<span class="c1">#        print([u.agid for u in population])</span>
        <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="n">population</span><span class="p">:</span>
            <span class="n">unit</span><span class="o">.</span><span class="n">remove_host</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">keys</span><span class="p">)</span></div>


    <span class="k">def</span> <span class="nf">_base_move</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">other_unit</span><span class="p">,</span> <span class="n">agents</span><span class="o">=</span><span class="p">[],</span> <span class="o">**</span><span class="n">others</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">agents</span><span class="p">)</span>
        <span class="n">other_unit</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">agents</span><span class="p">)</span>


    <span class="nd">@abc</span><span class="o">.</span><span class="n">abstractmethod</span>
    <span class="k">def</span> <span class="nf">__iter__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">pass</span>

    <span class="c1"># TODO: shuffle content first</span>
<div class="viewcode-block" id="Aggregation.evolve"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.Aggregation.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">machine</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Ask each unit in the current compartment to make its content evolve</span>
<span class="sd">        according to its own capabilities. A specific state machine</span>
<span class="sd">        can be specified if needed.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">evolve</span><span class="p">(</span><span class="n">machine</span><span class="o">=</span><span class="n">machine</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">recursive</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">statevars</span><span class="o">.</span><span class="n">_is_active</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">unit</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">:</span>
                <span class="n">unit</span><span class="o">.</span><span class="n">evolve</span><span class="p">(</span><span class="n">machine</span><span class="o">=</span><span class="n">machine</span><span class="p">)</span></div>

<div class="viewcode-block" id="Aggregation.detach_model"><a class="viewcode-back" href="../../../../emulsion.agent.core.html#emulsion.agent.core.groups.Aggregation.detach_model">[docs]</a>    <span class="k">def</span> <span class="nf">detach_model</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Recursively remove the reference to the model in all</span>
<span class="sd">        agents. Required before serialization.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="n">detach_model</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">agent</span> <span class="ow">in</span> <span class="bp">self</span><span class="p">:</span>
            <span class="n">agent</span><span class="o">.</span><span class="n">detach_model</span><span class="p">()</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../../index.html">Documentation overview</a><ul>
  <li><a href="../../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>